require "import"
import "android.media.AudioManager"
import "android.content.Context"
import "com.androlua.LuaDialog"
import "android.widget.LinearLayout"
import "android.widget.Button"

context = activity or service
audioManager = context.getSystemService(Context.AUDIO_SERVICE)

local function getVolumePercentage(streamType)
  local currentVolume = audioManager.getStreamVolume(streamType)
  local maxVolume = audioManager.getStreamMaxVolume(streamType)
  return math.floor((currentVolume / maxVolume) * 100)
end

local function adjustVolume(streamType, direction)
  local adjustDirection = (direction == "raise") and AudioManager.ADJUST_RAISE or AudioManager.ADJUST_LOWER
  local currentVolume = audioManager.getStreamVolume(streamType)
  local newVolume = currentVolume + (direction == "raise" and 1 or -1)

  if newVolume < 0 then
    newVolume = 0
  elseif newVolume > audioManager.getStreamMaxVolume(streamType) then
    newVolume = audioManager.getStreamMaxVolume(streamType)
  end

  audioManager.setStreamVolume(streamType, newVolume, 0)

  local streamName = ""
  if streamType == AudioManager.STREAM_MUSIC then
    streamName = "Музыка"
  elseif streamType == AudioManager.STREAM_NOTIFICATION then
    streamName = "Уведомления"
  end

    local volumePercentage = getVolumePercentage(streamType)
    service.postSpeak(100, "Громкость " .. streamName .. ": " .. volumePercentage .. " процентов")

  dlg.dismiss()
end

layout = {
  LinearLayout,
  orientation = 1,

  {
    Button,
    text = "Увеличить громкость музыки",
    onClick = function()
      adjustVolume(AudioManager.STREAM_MUSIC, "raise")
    end
  },
    {
    Button,
    text = "Уменьшить громкость музыки",
    onClick = function()
      adjustVolume(AudioManager.STREAM_MUSIC, "lower")
    end
  },
  {
    Button,
    text = "Увеличить громкость уведомлений",
    onClick = function()
      adjustVolume(AudioManager.STREAM_NOTIFICATION, "raise")
    end
  },
  {
    Button,
    text = "Уменьшить громкость уведомлений",
    onClick = function()
      adjustVolume(AudioManager.STREAM_NOTIFICATION, "lower")
    end
  },
}

dlg = LuaDialog(context)
dlg.setView(loadlayout(layout))
dlg.setTitle("Громкость")
dlg.show()